﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Data.Services.Client;
using SilverlightCompression.ServiceReference1;
using System.IO;
using System.Runtime.Serialization.Json;
using System.Xml;
using System.Windows.Browser;
using System.Json;
using System.Text;

namespace SilverlightCompression
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();

            BeginATOMRequest();

            BeginJSONRequest();
        }

        private void BeginATOMRequest()
        {
            DataServiceContext context = new DataServiceContext(new Uri("WebDataService1.svc", UriKind.Relative));
            DataServiceQuery<Customers> query = context.CreateQuery<Customers>("Customers");
            query.BeginExecute(ATOMRequestCompleted, query);
        }

        private void ATOMRequestCompleted(IAsyncResult asyncResult)
        {
            DataServiceQuery<Customers> query = asyncResult.AsyncState as DataServiceQuery<Customers>;
            RadGridView1.ItemsSource = query.EndExecute(asyncResult).ToList();
        }

        private void BeginJSONRequest()
        {
            Uri documentUri = HtmlPage.Document.DocumentUri;
            Uri uri = new Uri(String.Format("{0}://{1}:{2}/{3}", documentUri.Scheme, documentUri.Host, documentUri.Port, "WebDataService1.svc/Customers"), UriKind.Absolute);

            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(uri);
            request.Method = "GET";
            request.Accept = "application/json";
            IAsyncResult result = request.BeginGetResponse(new AsyncCallback(JSONRequestCompleted), request);
        }

        private void JSONRequestCompleted(IAsyncResult result)
        {
            HttpWebRequest request = (HttpWebRequest)result.AsyncState;
            HttpWebResponse response = (HttpWebResponse)request.EndGetResponse(result);

            List<Customers> list = new List<Customers>();

            using (Stream stream = (Stream)response.GetResponseStream())
            {
                JsonValue items = JsonArray.Load(stream);

                foreach (KeyValuePair<string, JsonValue> item in items)
                {
                    if (item.Key == "d")
                    {
                        JsonArray array = (JsonArray)item.Value;

                        DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(Customers));

                        foreach (JsonObject child in array)
                        {
                            using (MemoryStream jsonStream = new MemoryStream(Encoding.Unicode.GetBytes(child.ToString())))
                            {
                                Customers customer = (Customers)serializer.ReadObject(jsonStream);
                                list.Add(customer);
                            }
                        }
                    }
                }
            }

            Dispatcher.BeginInvoke(() =>
            {
                RadGridView2.ItemsSource = list;
            });
        }
    }
}
